import binarytree.*;

class UseBinaryTree {

    public static void main(String[] args) {
	BinaryTree tree3 = new BinaryTree(new Integer(70));

	BinaryTree tree1 = new BinaryTree();
	tree1.setRootItem(new Integer(40));
	tree1.attachLeft(new Integer(30));
	tree1.attachRight(new Integer(50));
	
	BinaryTree tree2 = new BinaryTree();
	tree2.setRootItem(new Integer(20));
	tree2.attachLeft(new Integer(10));
	tree2.attachRightSubtree(tree1);

	BinaryTree binTree = 
	    new BinaryTree(new Integer(60), tree2, tree3);

	TreeIterator btIterator = new TreeIterator(binTree);
	btIterator.setInorder();

	System.out.println("The whole tree, in order:");
	while(btIterator.hasNext()) {
	    System.out.println(btIterator.next());
	}

	BinaryTree leftTree = binTree.detachLeftSubtree();
	TreeIterator leftIterator = new TreeIterator(leftTree);
	leftIterator.setInorder();

	System.out.println("The left tree, in order:");
	while(leftIterator.hasNext()) {
	    System.out.println(leftIterator.next());
	}

	System.out.println("The rest of the tree, in order:");
	btIterator.setInorder();
	while(btIterator.hasNext()) {
	    System.out.println(btIterator.next());
	}
    }
}
