package binarytree;

import queue.*;

public class TreeIterator implements java.util.Iterator {
    private BinaryTreeBasis binTree;
    private TreeNode currentNode;
    private Queue queue;
    
    public TreeIterator(BinaryTreeBasis bTree) {
	binTree = bTree;
	currentNode = null;
	queue = new Queue();
    }
    
    public boolean hasNext() {
	return	!queue.isEmpty();
    }

    public Object next() 
	throws java.util.NoSuchElementException {
	try {
	    currentNode = (TreeNode)queue.dequeue();
	    return currentNode.getItem();
	} catch (QueueException e) {
	    throw new java.util.NoSuchElementException();
	}
    }

    public void remove() 
	throws UnsupportedOperationException {
	throw new UnsupportedOperationException(
	"UnsupportedOperationException: remove not implemented");
    }

    public void setPreorder() {
	queue.dequeueAll();
	preorder(binTree.root);
    }

    public void setInorder() {
	queue.dequeueAll();
	inorder(binTree.root);
    }

    public void setPostorder() {
	queue.dequeueAll();
	postorder(binTree.root);
    }

    private void preorder(TreeNode treeNode) {
	if(treeNode != null) {
	    queue.enqueue(treeNode);
	    preorder(treeNode.getLeft());
	    preorder(treeNode.getRight());
	}
    }

    private void inorder(TreeNode treeNode) {
	if(treeNode != null) {
	    inorder(treeNode.getLeft());
	    queue.enqueue(treeNode);
	    inorder(treeNode.getRight());
	}
    }

    private void postorder(TreeNode treeNode) {
	if(treeNode != null) {
	    postorder(treeNode.getLeft());
	    postorder(treeNode.getRight());
	    queue.enqueue(treeNode);
	}
    }
}
