package linkedlist;

class Node {
    // The object stored in the node
    private Object item;

    // A reference to the next node in the list
    private Node next;
    
    /*
     * Node()
     * A constructor, creates an empty node
     */
    public Node(Object newItem) {
	item = newItem;
	next = null;
    }

    /*
     * Node()
     * Another constructor, creates a non-empty node
     */
    public Node(Object newItem, Node nextNode) {
	item = newItem;
	next = nextNode;
    }

    /*
     * setItem()
     * Sets the item for this node
     */
    public void setItem(Object newItem) {
	item = newItem;
    }

    /*
     * getItem()
     * returns the item for this node
     */
    public Object getItem() {
	return item;
    }

    /*
     * SetNext()
     * Sets the next reference for this node
     */
    public void setNext(Node nextNode) {
	next = nextNode;
    }

    /*
     * getNext()
     * returns the next reference for this node
     */
    public Node getNext() {
	return next;
    }
}
